searchNodes=[{"doc":"Poolex is a library for managing a pool of processes. Inspired by poolboy . Requirements Requirement Version Erlang/OTP &gt;= 22 Elixir &gt;= 1.7 Installation Add :poolex to your list of dependencies in mix.exs : def deps do [ { :poolex , &quot;~&gt; 0.2.0&quot; } ] end Usage This example is based on the Elixir School's poolboy guide . You can find the source of the below example here: poolex_example . Defining the worker We describe an actor that can easily become a bottleneck in our application, since it has a rather long execution time on a blocking call. defmodule PoolexExample.Worker do use GenServer def start do GenServer . start ( __MODULE__ , nil ) end def init ( _args ) do { :ok , nil } end def handle_call ( { :square_root , x } , _from , state ) do IO . puts ( &quot;process \#{ inspect ( self ( ) ) } calculating square root of \#{ x } &quot; ) Process . sleep ( 1_000 ) { :reply , :math . sqrt ( x ) , state } end end Configuring Poolex defmodule PoolexExample.Application do @moduledoc false use Application defp worker_config do [ worker_module : PoolexExample.Worker , workers_count : 5 ] end def start ( _type , _args ) do children = [ %{ id : :worker_pool , start : { Poolex , :start_link , [ :worker_pool , worker_config ( ) ] } } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end List of possible configuration options: Option Description Example Default value worker_module Name of module that implements our worker MyApp.Worker option is required worker_start_fun Name of the function that starts the worker :run :start worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] workers_count How many workers should be running in the pool 5 option is required Using Poolex Poolex.run/3 is the function that you can use to interface with the worker pool. The first parameter is the pool ID (see Poolex configuration). The second parameter is a function that takes the pid of the worker and performs the necessary operation with it. The third parameter is a keyword of run options. :timeout -- Worker timeout on the side of the calling process. For example, if the timeout is 1000 and no free workers have appeared in the pool for a second, then the execution will abort with raising an error. The default value for this parameter is 5 seconds. defmodule PoolexExample.Test do @timeout 60_000 def start do 1 .. 20 |&gt; Enum . map ( fn i -&gt; async_call_square_root ( i ) end ) |&gt; Enum . each ( fn task -&gt; await_and_inspect ( task ) end ) end defp async_call_square_root ( i ) do Task . async ( fn -&gt; Poolex . run ( :worker_pool , fn pid -&gt; # Let&#39;s wrap the genserver call in a try - catch block. This allows us to trap any exceptions # that might be thrown and return the worker back to poolboy in a clean manner. It also allows # the programmer to retrieve the error and potentially fix it. try do GenServer . call ( pid , { :square_root , i } ) catch e , r -&gt; IO . inspect ( &quot;poolboy transaction caught error: \#{ inspect ( e ) } , \#{ inspect ( r ) } &quot; ) :ok end end , timeout : @timeout ) end ) end defp await_and_inspect ( task ) , do : task |&gt; Task . await ( @timeout ) |&gt; IO . inspect ( ) end Run the test function and see the result. iex -S mix iex&gt; PoolexExample.Test . start process # PID &lt; 0 . 227 . 0 &gt; calculating square root of 5 process # PID &lt; 0 . 223 . 0 &gt; calculating square root of 1 process # PID &lt; 0 . 225 . 0 &gt; calculating square root of 3 process # PID &lt; 0 . 224 . 0 &gt; calculating square root of 2 process # PID &lt; 0 . 226 . 0 &gt; calculating square root of 4 { :ok , 1.0 } { :ok , 1.4142135623730951 } { :ok , 1.7320508075688772 } { :ok , 2.0 } { :ok , 2.23606797749979 } { :ok , 2.449489742783178 } ...","ref":"Poolex.html","title":"Poolex","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Poolex.html#child_spec/1","title":"Poolex.child_spec/1","type":"function"},{"doc":"","ref":"Poolex.html#get_state/1","title":"Poolex.get_state/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Poolex.html#init/1","title":"Poolex.init/1","type":"function"},{"doc":"","ref":"Poolex.html#run/3","title":"Poolex.run/3","type":"function"},{"doc":"","ref":"Poolex.html#run!/3","title":"Poolex.run!/3","type":"function"},{"doc":"","ref":"Poolex.html#start/2","title":"Poolex.start/2","type":"function"},{"doc":"","ref":"Poolex.html#start_link/2","title":"Poolex.start_link/2","type":"function"},{"doc":"","ref":"Poolex.html#t:pool_id/0","title":"Poolex.pool_id/0","type":"type"},{"doc":"","ref":"Poolex.html#t:poolex_option/0","title":"Poolex.poolex_option/0","type":"type"},{"doc":"","ref":"Poolex.html#t:run_option/0","title":"Poolex.run_option/0","type":"type"},{"doc":"Interfaces to hide monitoring implementation.","ref":"Poolex.Monitoring.html","title":"Poolex.Monitoring","type":"module"},{"doc":"","ref":"Poolex.Monitoring.html#add/3","title":"Poolex.Monitoring.add/3","type":"function"},{"doc":"","ref":"Poolex.Monitoring.html#init/1","title":"Poolex.Monitoring.init/1","type":"function"},{"doc":"","ref":"Poolex.Monitoring.html#remove/2","title":"Poolex.Monitoring.remove/2","type":"function"},{"doc":"","ref":"Poolex.Monitoring.html#t:kind_of_process/0","title":"Poolex.Monitoring.kind_of_process/0","type":"type"},{"doc":"","ref":"Poolex.Monitoring.html#t:monitor_id/0","title":"Poolex.Monitoring.monitor_id/0","type":"type"},{"doc":"Poolex is a library for managing a pool of processes. Inspired by poolboy .","ref":"readme.html","title":"Poolex","type":"extras"},{"doc":"Requirement Version Erlang/OTP &gt;= 22 Elixir &gt;= 1.7","ref":"readme.html#requirements","title":"Poolex - Requirements","type":"extras"},{"doc":"Add :poolex to your list of dependencies in mix.exs : def deps do [ { :poolex , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Poolex - Installation","type":"extras"},{"doc":"This example is based on the Elixir School's poolboy guide . You can find the source of the below example here: poolex_example . Defining the worker We describe an actor that can easily become a bottleneck in our application, since it has a rather long execution time on a blocking call. defmodule PoolexExample.Worker do use GenServer def start do GenServer . start ( __MODULE__ , nil ) end def init ( _args ) do { :ok , nil } end def handle_call ( { :square_root , x } , _from , state ) do IO . puts ( &quot;process \#{ inspect ( self ( ) ) } calculating square root of \#{ x } &quot; ) Process . sleep ( 1_000 ) { :reply , :math . sqrt ( x ) , state } end end Configuring Poolex defmodule PoolexExample.Application do @moduledoc false use Application defp worker_config do [ worker_module : PoolexExample.Worker , workers_count : 5 ] end def start ( _type , _args ) do children = [ %{ id : :worker_pool , start : { Poolex , :start_link , [ :worker_pool , worker_config ( ) ] } } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end List of possible configuration options: Option Description Example Default value worker_module Name of module that implements our worker MyApp.Worker option is required worker_start_fun Name of the function that starts the worker :run :start worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] workers_count How many workers should be running in the pool 5 option is required Using Poolex Poolex.run/3 is the function that you can use to interface with the worker pool. The first parameter is the pool ID (see Poolex configuration). The second parameter is a function that takes the pid of the worker and performs the necessary operation with it. The third parameter is a keyword of run options. :timeout -- Worker timeout on the side of the calling process. For example, if the timeout is 1000 and no free workers have appeared in the pool for a second, then the execution will abort with raising an error. The default value for this parameter is 5 seconds. defmodule PoolexExample.Test do @timeout 60_000 def start do 1 .. 20 |&gt; Enum . map ( fn i -&gt; async_call_square_root ( i ) end ) |&gt; Enum . each ( fn task -&gt; await_and_inspect ( task ) end ) end defp async_call_square_root ( i ) do Task . async ( fn -&gt; Poolex . run ( :worker_pool , fn pid -&gt; # Let&#39;s wrap the genserver call in a try - catch block. This allows us to trap any exceptions # that might be thrown and return the worker back to poolboy in a clean manner. It also allows # the programmer to retrieve the error and potentially fix it. try do GenServer . call ( pid , { :square_root , i } ) catch e , r -&gt; IO . inspect ( &quot;poolboy transaction caught error: \#{ inspect ( e ) } , \#{ inspect ( r ) } &quot; ) :ok end end , timeout : @timeout ) end ) end defp await_and_inspect ( task ) , do : task |&gt; Task . await ( @timeout ) |&gt; IO . inspect ( ) end Run the test function and see the result. iex -S mix iex&gt; PoolexExample.Test . start process # PID &lt; 0 . 227 . 0 &gt; calculating square root of 5 process # PID &lt; 0 . 223 . 0 &gt; calculating square root of 1 process # PID &lt; 0 . 225 . 0 &gt; calculating square root of 3 process # PID &lt; 0 . 224 . 0 &gt; calculating square root of 2 process # PID &lt; 0 . 226 . 0 &gt; calculating square root of 4 { :ok , 1.0 } { :ok , 1.4142135623730951 } { :ok , 1.7320508075688772 } { :ok , 2.0 } { :ok , 2.23606797749979 } { :ok , 2.449489742783178 } ...","ref":"readme.html#usage","title":"Poolex - Usage","type":"extras"}]